## qtcreator 17.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

option(BUILD_DESIGNSTUDIO "Build and install design studio plugins, examples and settings." OFF)
if (BUILD_DESIGNSTUDIO)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/dist/branding/qtdesignstudio")
endif()

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Utils)

env_with_default("QTC_BUILD_WITH_PCH" ENV_QTC_BUILD_WITH_PCH ON)
env_with_default("QTC_WITH_TESTS" ENV_QTC_WITH_TESTS OFF)

option(BUILD_WITH_PCH "Build with precompiled headers" "${ENV_QTC_BUILD_WITH_PCH}")

include(FeatureSummary)
include(QtCreatorIDEBranding RESULT_VARIABLE IDE_BRANDING_FILE)
include(QtCreatorTranslations)
include(QtCreatorDocumentation)
include(QtCreatorAPI)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")
set(IDE_REVISION_URL "" CACHE STRING "The IDE revision Url string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR IDE_REVISION_URL)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

qtc_handle_compiler_cache_support()
qtc_handle_llvm_linker()

option(WITH_TESTS "Build Tests" ${ENV_QTC_WITH_TESTS})
add_feature_info("Build tests" ${WITH_TESTS} "")
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality" OFF)
option(SHOW_BUILD_DATE "Show build date in about dialog" OFF)
option(WITH_SANITIZE "Build with sanitizer enabled" OFF)
set(SANITIZE_FLAGS "" CACHE STRING "Sets flags for sanitizer compilation flags used in Debug builds")
add_feature_info("Build with sanitize" ${WITH_SANITIZE} "SANITIZE_FLAGS='${SANITIZE_FLAGS}'")


# merge binary directories of sub projects into top level
set(QTC_MERGE_BINARY_DIR ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt::Test)
endif()

# suppress bogus warning
# warning C4573 requires the compiler to capture 'this' but the current default capture mode does not allow it
# when using QObject::connect in lambda without capturing 'this' - which would lead to warnings
# with other compilers
if(MSVC)
  add_compile_options(/wd4573)
endif()

find_package(Qt6
  ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Network PrintSupport Qml Sql Widgets Xml Core5Compat ${QT_TEST_COMPONENT}
  REQUIRED
)

find_package(Qt6 OPTIONAL_COMPONENTS Quick QuickWidgets Designer DesignerComponentsPrivate
                                     Help SerialPort Svg Tools LinguistTools QUIET)

if (Qt6_VERSION VERSION_GREATER_EQUAL 6.9.0)
  find_package(Qt6 OPTIONAL_COMPONENTS
    CorePrivate
    Core5CompatPrivate
    GuiPrivate
    DesignerComponentsPrivate
    QmlPrivate
    QuickPrivate
    QUIET
  )
endif()

# depending on Qt version and compiler version enable or disable Qml Designer
# can be overwritten by variable WITH_QMLDESIGNER / QTC_WITH_QMLDESIGNER (env)
configure_qml_designer(${Qt6_VERSION})

# hack for Qbs which still supports Qt5 and Qt6
if (TARGET Qt6::Core5CompatPrivate)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5CompatPrivate PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5CompatPrivate ALIAS Qt6::Core5CompatPrivate)
endif()
if (TARGET Qt6::Core5Compat)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5Compat PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5Compat ALIAS Qt6::Core5Compat)
endif()

# Common intermediate directory for QML modules which are defined via qt_add_qml_module()
set(QT_QML_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/qml_modules")

# This includes the code that will enable higher compiler warnings level (/W3 for MSVC, -Wall -Wextra for GCC)
# This is controlled by QT_COMPILE_OPTIONS_DISABLE_WARNINGS target property.
include(QtCompilerFlags)

if (MSVC AND QT_FEATURE_static_runtime)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

find_package(Threads)
find_package(Clang QUIET)

# Crashpad
set(CRASHPAD_BACKEND_URL "$ENV{QTC_CRASHPAD_BACKEND_URL}" CACHE STRING "Crashpad backend URL")
set(BUILD_WITH_CRASHPAD OFF)
# Linux is not supported for now
if(CRASHPAD_BACKEND_URL AND (WIN32 OR APPLE)) # Linux is not supported for now
  find_package(Crashpad QUIET)
  if(TARGET Crashpad::Crashpad)
    set(BUILD_WITH_CRASHPAD ON)
  endif()
endif()
add_feature_info("Build with Crashpad" ${BUILD_WITH_CRASHPAD} "")

set(SENTRY_DSN "$ENV{QTC_SENTRY_DSN}" CACHE STRING "Data Source Name to use for sending Sentry events.")
set(SENTRY_PROJECT "" CACHE STRING "Project ID to use for sending Sentry events.")
set(BUILD_WITH_SENTRY OFF)
if(SENTRY_DSN AND SENTRY_PROJECT)
  find_package(sentry QUIET)
  if(TARGET sentry::sentry)
    set(BUILD_WITH_SENTRY ON)
    get_target_property(__sentry_configs sentry::sentry IMPORTED_CONFIGURATIONS)
    get_target_property(__sentry_lib sentry::sentry IMPORTED_LOCATION_${__sentry_configs})
    install(FILES ${__sentry_lib}
      DESTINATION "${IDE_LIBRARY_ARCHIVE_PATH}"
      COMPONENT Dependencies
      EXCLUDE_FROM_ALL
    )
    if (TARGET sentry_crashpad::crashpad_handler)
      get_target_property(SENTRY_CRASHPAD_PATH sentry_crashpad::crashpad_handler IMPORTED_LOCATION_${__sentry_configs})
      install(PROGRAMS ${SENTRY_CRASHPAD_PATH}
        DESTINATION "${IDE_LIBEXEC_PATH}"
        COMPONENT Dependencies
        EXCLUDE_FROM_ALL
      )
    endif()
  endif()
endif()
add_feature_info("Build with Sentry" ${BUILD_WITH_SENTRY} "")

function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

add_library(OptionalSvg INTERFACE)
if (TARGET Qt::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

if (WITH_TESTS)
  enable_testing()
endif()

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)
if (NOT BUILD_DESIGNSTUDIO)
    add_subdirectory(dist)
endif()

if (WITH_TESTS)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

setup_dependencies_component()

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
    AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/LICENSES/LICENSE.GPL3-EXCEPT")
  # Only for opensource, non-super-repo builds
  add_subdirectory(packaging)
endif()

=== doc/CMakeLists.txt ===
# Generate documentation

option(BUILD_DEVELOPER_DOCS "Include developer documentation" OFF)
add_feature_info("Include developer documentation" BUILD_DEVELOPER_DOCS "")

function(_find_all_includes _ret_includes _ret_framework_paths)
  set(_all_includes "${PROJECT_SOURCE_DIR}/src/plugins;${PROJECT_SOURCE_DIR}/src/libs")
  foreach(_target ${__QTC_PLUGINS} ${__QTC_LIBRARIES})
    if (NOT TARGET ${_target})
      continue()
    endif()
    get_target_property(_includes ${_target} INCLUDE_DIRECTORIES)
    foreach(_include ${_includes})
      string(FIND "${_include}" "/src/plugins/" _in_plugins)
      string(FIND "${_include}" "/src/libs/" _in_libs)
      string(FIND "${_include}" "${CMAKE_BINARY_DIR}" _in_build)
      string(REGEX MATCH "\\$<TARGET_PROPERTY:([^,]+).*>" _property_match "${_include}")
      set(_property_target "${CMAKE_MATCH_1}")
      if(_in_plugins LESS 0 AND _in_libs LESS 0 AND _in_build LESS 0 AND (NOT _property_target OR TARGET ${_property_target}))
        list(APPEND _all_includes ${_include})
      endif()
    endforeach()
  endforeach()
  list(APPEND _all_includes ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES})
  list(REMOVE_DUPLICATES _all_includes)
  set("${_ret_includes}" "${_all_includes}" PARENT_SCOPE)

  # framework path
  if (APPLE)
    get_target_property(_qt_type Qt::Core TYPE)
    if ("${_qt_type}" STREQUAL "INTERFACE_LIBRARY")
        # version-less target Qt::Core is an interface library that links to QtX::Core
        get_target_property(_qt_core Qt::Core INTERFACE_LINK_LIBRARIES)
    else()
        set(_qt_core "Qt::Core")
    endif()
    get_target_property(_qt_target ${_qt_core} LOCATION)
    # eg <fw_path>/QtCore.framework/QtCore
    # or <fw_path>/QtCore.framework/Versions/A/QtCore
    # cut off /QtCore.framework/*
    string(REGEX REPLACE "/QtCore.framework/.*" "" _qt_loc "${_qt_target}")
    set("${_ret_framework_paths}" "${_qt_loc}" PARENT_SCOPE)
  endif()
endfunction()

function(_add_doc _doc_file _dev_doc_file)
  set(GENERATED_ATTRIBUTIONS_DIR ${CMAKE_CURRENT_BINARY_DIR}/generated_attributions)
  add_qtc_documentation(${_doc_file}
    ENVIRONMENT_EXPORTS GENERATED_ATTRIBUTIONS_DIR
  )
  set(attribution_src "${CMAKE_CURRENT_SOURCE_DIR}/../qt_attributions.json")
  set(attribution_dest "${CMAKE_CURRENT_BINARY_DIR}/qt_attributions.json")
  qtc_prepare_attribution_file("${attribution_src}" "${attribution_dest}")
  add_qtc_doc_attribution(doc_attributions
    "${attribution_dest}"
    "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions.qdoc"
    ${_doc_file}
  )
  set(litehtml_attributions "${CMAKE_CURRENT_SOURCE_DIR}/../src/libs/qlitehtml/src/3rdparty/qt_attribution.json")
  if(EXISTS "${litehtml_attributions}")
    add_qtc_doc_attribution(doc_attributions_litehtml
      "${litehtml_attributions}"
      "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions-litehtml.qdoc"
      ${_doc_file}
    )
  endif()
  if (BUILD_DEVELOPER_DOCS)
    _find_all_includes(_all_includes _framework_paths)
    add_qtc_documentation(${_dev_doc_file}
      INCLUDE_DIRECTORIES ${_all_includes}
      FRAMEWORK_PATHS ${_framework_paths}
    )
  endif()
endfunction()

if (WITH_DOCS)
  _add_doc(${IDE_DOC_FILE} "qtcreatordev/qtcreator-dev.qdocconf")
endif()
if(WITH_ONLINE_DOCS)
  _add_doc(${IDE_DOC_FILE_ONLINE} "qtcreatordev/qtcreator-dev-online.qdocconf")
endif()

if (BUILD_DOCS_BY_DEFAULT)
set(EXCLUDE_DOCS_FROM_ALL "")
else()
set(EXCLUDE_DOCS_FROM_ALL "EXCLUDE_FROM_ALL")
endif()

install(DIRECTORY config
  DESTINATION ${IDE_HEADER_INSTALL_PATH}/doc
  COMPONENT Devel
  ${EXCLUDE_DOCS_FROM_ALL}
)

=== tests/manual/CMakeLists.txt ===
# add_subdirectory(autotoolsprojectmanager)
# add_subdirectory(clang-format-for-qtc)
# add_subdirectory(cplusplus-tools)
# add_subdirectory(cppquickfix)
add_subdirectory(debugger)
add_subdirectory(deviceshell)
# add_subdirectory(distribution)
# add_subdirectory(dockwidgets)
add_subdirectory(fakevim)
# add_subdirectory(features)
# add_subdirectory(filesystemview)
# add_subdirectory(genericproject)
add_subdirectory(pluginview)
add_subdirectory(proparser)
add_subdirectory(terminal)
# add_subdirectory(qml)
# add_subdirectory(qt4projectmanager)
# add_subdirectory(search)
add_subdirectory(shootout)
add_subdirectory(spinner)
add_subdirectory(subdirfilecontainer)
add_subdirectory(tasking)
add_subdirectory(widgets)
add_subdirectory(cmdbridge)
add_subdirectory(scripts)

=== src/libs/3rdparty/CMakeLists.txt ===
add_subdirectory(cplusplus)
add_subdirectory(syntax-highlighting)
add_subdirectory(libvterm)
add_subdirectory(libptyqt)
add_subdirectory(qrcodegen)
add_subdirectory(qtkeychain)
add_subdirectory(lua)
add_subdirectory(sol2)

if(WIN32)
    add_subdirectory(winpty)
endif()

find_package(LibArchive QUIET)

if(LibArchive_FOUND)
  set(QTC_USE_SYSTEM_LIBARCHIVE_DEFAULT ON)
else()
  set(QTC_USE_SYSTEM_LIBARCHIVE_DEFAULT OFF)
endif()
option(QTC_USE_SYSTEM_LIBARCHIVE "Use the system provided libarchive" ${QTC_USE_SYSTEM_LIBARCHIVE_DEFAULT})

if (NOT QTC_USE_SYSTEM_LIBARCHIVE)
    add_subdirectory(xz)
    add_subdirectory(bzip2)
    add_subdirectory(zlib)

    set(ENABLE_WERROR OFF)
    set(ENABLE_TEST OFF)
    set(ENABLE_INSTALL OFF)
    set(BUILD_SHARED_LIBS OFF)

    add_subdirectory(libarchive)
    add_library(QtCLibArchive ALIAS archive_static)

    IF (NOT MSVC)
      # Disable warnings
      target_compile_options(archive_static PRIVATE "-w")
    ENDIF()
else()
    # make IMPORTED_GLOBAL to be able to create ALIAS target
    set_property(TARGET LibArchive::LibArchive PROPERTY IMPORTED_GLOBAL TRUE)
    add_library(QtCLibArchive ALIAS LibArchive::LibArchive)
endif()

add_feature_info("Use system libarchive" QTC_USE_SYSTEM_LIBARCHIVE "")

=== src/libs/advanceddockingsystem/CMakeLists.txt ===
add_qtc_library(AdvancedDockingSystem
  CONDITION TARGET Qt::QuickWidgets
  DEPENDS Qt::Widgets Qt::Core Qt::Gui Qt::Xml Qt::QuickWidgets Utils
  SOURCES
    ads_globals.cpp ads_globals.h
    advanceddockingsystemtr.h
    autohidedockcontainer.cpp autohidedockcontainer.h
    autohidesidebar.cpp autohidesidebar.h
    autohidetab.cpp autohidetab.h
    dockareatabbar.cpp dockareatabbar.h
    dockareatitlebar.cpp dockareatitlebar.h
    dockareawidget.cpp dockareawidget.h
    dockcomponentsfactory.cpp dockcomponentsfactory.h
    dockcontainerwidget.cpp dockcontainerwidget.h
    dockfocuscontroller.cpp dockfocuscontroller.h
    dockingstatereader.cpp dockingstatereader.h
    dockmanager.cpp dockmanager.h
    dockoverlay.cpp dockoverlay.h
    docksplitter.cpp docksplitter.h
    dockwidget.cpp dockwidget.h
    dockwidgettab.cpp dockwidgettab.h
    elidinglabel.cpp elidinglabel.h
    floatingdockcontainer.cpp floatingdockcontainer.h
    floatingdragpreview.cpp floatingdragpreview.h
    iconprovider.cpp iconprovider.h
    pushbutton.cpp pushbutton.h
    resizehandle.cpp resizehandle.h
    workspace.cpp workspace.h
    workspacedialog.cpp workspacedialog.h
    workspaceinputdialog.cpp workspaceinputdialog.h
    workspacemodel.cpp workspacemodel.h
    workspaceview.cpp workspaceview.h
)

extend_qtc_library(AdvancedDockingSystem
  INCLUDES linux
  CONDITION UNIX AND NOT APPLE
  SOURCES
    linux/floatingwidgettitlebar.cpp linux/floatingwidgettitlebar.h
)

=== src/libs/qmlpuppetcommunication/CMakeLists.txt ===
include(QmlPuppetCommunication.cmake)

=== src/libs/sqlite/CMakeLists.txt ===
env_with_default("QTC_ENABLE_SQLITE_TRACING" ENV_QTC_ENABLE_SQLITE_TRACING OFF)
option(ENABLE_SQLITE_TRACING "Enable sqlite tarcing" ${ENV_QTC_ENABLE_SQLITE_TRACING})
add_feature_info("Sqlite tracing" ${ENABLE_SQLITE_TRACING} "")

add_qtc_library(SqliteInternal OBJECT
    PROPERTIES AUTOMOC OFF AUTOUIC OFF QT_COMPILE_OPTIONS_DISABLE_WARNINGS ON
    DEFINES SQLITE_CORE SQLITE_CUSTOM_INCLUDE=config.h $<$<CONFIG:Debug>:SQLITE_DEBUG>
    INCLUDES
      ../3rdparty/sqlite
    SOURCES
      ../3rdparty/sqlite
      ../3rdparty/sqlite/sqlite3.c
      ../3rdparty/sqlite/sqlite3.h
      ../3rdparty/sqlite/sqlite3ext.h
      ../3rdparty/sqlite/carray.c
      ../3rdparty/sqlite/config.h
      ../3rdparty/sqlite/sqlite_static_config.h
      ../3rdparty/sqlite/sqlite.h
)

extend_qtc_library(SqliteInternal
  CONDITION QTC_STATIC_BUILD
  PRIVATE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FIsqlite_static_config.h,-includesqlite_static_config.h>
)

if (APPLE)
  extend_qtc_library(SqliteInternal DEFINES _BSD_SOURCE)
elseif (UNIX)
  extend_qtc_library(SqliteInternal DEFINES _POSIX_C_SOURCE=200809L _GNU_SOURCE _DEFAULT_SOURCE)
endif()

add_qtc_library(Sqlite
  PROPERTIES AUTOMOC OFF AUTOUIC OFF
  DEPENDS Qt::Core Threads::Threads ${CMAKE_DL_LIBS} SqliteInternal Nanotrace
  INCLUDES
    ../3rdparty/sqlite
  PUBLIC_INCLUDES
    "${CMAKE_CURRENT_LIST_DIR}"
  DEFINES SQLITE_CUSTOM_INCLUDE=config.h $<$<CONFIG:Debug>:SQLITE_REVERSE>
  SOURCES
    constraints.h
    createtablesqlstatementbuilder.h
    lastchangedrowid.h
    sourcelocation.h
    sqlite3_fwd.h
    sqlitealgorithms.h
    sqlitebasestatement.cpp sqlitebasestatement.h
    sqlitecolumn.h
    sqlitedatabase.cpp sqlitedatabase.h
    sqlitedatabasebackend.cpp sqlitedatabasebackend.h
    sqlitedatabaseinterface.h
    sqliteexception.cpp sqliteexception.h
    sqliteglobal.cpp sqliteglobal.h
    sqlitefunctionregistry.cpp sqlitefunctionregistry.h
    sqliteindex.h
    sqliteprogresshandler.h
    sqlitereadstatement.h
    sqlitereadwritestatement.h
    sqlitesessionchangeset.cpp sqlitesessionchangeset.h
    sqlitesessions.cpp sqlitesessions.h
    sqlitetable.h
    sqlitetracing.cpp sqlitetracing.h
    sqlitetransaction.h
    sqlitevalue.h
    sqlitewritestatement.h
    sqlstatementbuilder.cpp sqlstatementbuilder.h
    sqlstatementbuilderexception.h
    tableconstraints.h
    sqliteblob.h
    sqlitetimestamp.h
    sqlitelibraryinitializer.cpp sqlitelibraryinitializer.h
    sqliteids.h
)

extend_qtc_library(Sqlite
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
  PUBLIC_DEFINES
    $<$<BOOL:${ENABLE_SQLITE_TRACING}>:ENABLE_SQLITE_TRACING>
)

extend_qtc_library(Sqlite
  CONDITION QTC_STATIC_BUILD
  PRIVATE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FIsqlite_static_config.h,-includesqlite_static_config.h>
  PROPERTIES
    INTERFACE_COMPILE_OPTIONS $<IF:$<CXX_COMPILER_ID:MSVC>,/FI../3rdparty/sqlite/sqlite_static_config.h,-include../3rdparty/sqlite/sqlite_static_config.h>
)

=== src/plugins/clangformat/CMakeLists.txt ===
add_qtc_plugin(ClangFormat
  CONDITION TARGET ${CLANG_FORMAT_LIB} AND LLVM_PACKAGE_VERSION VERSION_GREATER_EQUAL 14.0.0 AND (QTC_CLANG_BUILDMODE_MATCH OR CLANGTOOLING_LINK_CLANG_DYLIB)
  DEPENDS Utils Qt::Widgets ${CLANG_FORMAT_LIB}
  PLUGIN_DEPENDS Core TextEditor CppEditor ProjectExplorer
  SOURCES
    clangformatbaseindenter.cpp clangformatbaseindenter.h
    clangformatcodestylepreferencesfactory.cpp clangformatcodestylepreferencesfactory.h
    clangformatconfigwidget.cpp clangformatconfigwidget.h
    clangformatglobalconfigwidget.cpp clangformatglobalconfigwidget.h
    clangformatconstants.h
    clangformatfile.cpp clangformatfile.h
    clangformatindenter.cpp clangformatindenter.h
    clangformatplugin.cpp
    clangformatsettings.cpp clangformatsettings.h
    clangformattr.h
    clangformatutils.cpp clangformatutils.h
)

if(TARGET ClangFormat)
  # "system" includes, so warnings are ignored
  target_include_directories(ClangFormat SYSTEM PRIVATE "${CLANG_INCLUDE_DIRS}")
endif()

if(MSVC AND TARGET ClangFormat)
  target_compile_options(ClangFormat PUBLIC /wd4267 /wd4624)
endif()

extend_qtc_plugin(ClangFormat
  CONDITION UNIX AND NOT APPLE
  PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,ALL"
)

extend_qtc_plugin(ClangFormat
  CONDITION WITH_TESTS
  SOURCES
    tests/clangformat-test.cpp
    tests/clangformat-test.h
  DEFINES
    TESTDATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/tests/data"
)

extend_qtc_plugin(ClangFormat
  CONDITION TARGET LLVM
  DEPENDS LLVM
)

=== src/plugins/clangtools/CMakeLists.txt ===
find_package(yaml-cpp QUIET MODULE)

set(CLANG_VERSION ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})

add_qtc_plugin(ClangTools
  CONDITION TARGET yaml-cpp
  DEPENDS yaml-cpp
  PLUGIN_DEPENDS Core Debugger CppEditor
  PLUGIN_RECOMMENDS CppEditor
  PLUGIN_TEST_DEPENDS QmakeProjectManager QbsProjectManager
  SKIP_PCH
  DEFINES
    CLANG_VERSION="${CLANG_VERSION}"
    CLANG_INCLUDE_DIR="${LLVM_LIBRARY_DIR}/clang/${CLANG_VERSION}/include"
    CLANG_BINDIR="${LLVM_TOOLS_BINARY_DIR}"
  INCLUDES ${CLANG_INCLUDE_DIRS}
  SOURCES
    clangfileinfo.h
    clangfixitsrefactoringchanges.cpp clangfixitsrefactoringchanges.h
    clangselectablefilesdialog.cpp clangselectablefilesdialog.h
    clangtool.cpp clangtool.h
    clangtoolrunner.cpp clangtoolrunner.h
    clangtools_global.h
    clangtoolscompilationdb.cpp clangtoolscompilationdb.h
    clangtoolstr.h
    clangtoolsconstants.h
    clangtoolsdiagnostic.cpp clangtoolsdiagnostic.h
    clangtoolsdiagnosticmodel.cpp clangtoolsdiagnosticmodel.h
    clangtoolsdiagnosticview.cpp clangtoolsdiagnosticview.h
    clangtoolslogfilereader.cpp clangtoolslogfilereader.h
    clangtoolsplugin.cpp clangtoolsplugin.h
    clangtoolsprojectsettings.cpp clangtoolsprojectsettings.h
    clangtoolsprojectsettingswidget.cpp clangtoolsprojectsettingswidget.h
    clangtoolssettings.cpp clangtoolssettings.h
    clangtoolsutils.cpp clangtoolsutils.h
    diagnosticconfigswidget.cpp diagnosticconfigswidget.h
    diagnosticmark.cpp diagnosticmark.h
    documentclangtoolrunner.cpp documentclangtoolrunner.h
    documentquickfixfactory.cpp documentquickfixfactory.h
    executableinfo.cpp executableinfo.h
    filterdialog.cpp filterdialog.h
    inlinesuppresseddiagnostics.cpp inlinesuppresseddiagnostics.h
    runsettingswidget.cpp runsettingswidget.h
    settingswidget.cpp settingswidget.h
    virtualfilesystemoverlay.cpp virtualfilesystemoverlay.h
)

extend_qtc_plugin(ClangTools
  CONDITION WITH_TESTS
  SOURCES
    clangtoolspreconfiguredsessiontests.cpp clangtoolspreconfiguredsessiontests.h
    clangtoolsunittests.cpp clangtoolsunittests.h
    clangtoolsunittests.qrc
    readexporteddiagnosticstest.cpp readexporteddiagnosticstest.h
)

=== src/plugins/coreplugin/CMakeLists.txt ===
add_qtc_plugin(Core
  DEPENDS Qt::PrintSupport Qt::Qml Qt::Sql Qt::Gui Qt::GuiPrivate TerminalLib qtkeychain
  PUBLIC_DEPENDS Aggregation ExtensionSystem Utils
  SOURCES
    actionmanager/actioncontainer.cpp
    actionmanager/actioncontainer.h
    actionmanager/actioncontainer_p.h
    actionmanager/actionmanager.cpp
    actionmanager/actionmanager.h
    actionmanager/actionmanager_p.h
    actionmanager/command.cpp
    actionmanager/command.h
    actionmanager/command_p.h
    actionmanager/commandmappings.cpp
    actionmanager/commandmappings.h
    actionsfilter.cpp
    actionsfilter.h
    basefilewizard.cpp
    basefilewizard.h
    basefilewizardfactory.cpp
    basefilewizardfactory.h
    core.qrc
    core_global.h
    coreconstants.h
    coreicons.cpp
    coreicons.h
    corejsextensions.cpp
    corejsextensions.h
    coreplugin.cpp
    coreplugin.h
    coreplugintr.h
    credentialquery.cpp
    credentialquery.h
    designmode.cpp
    designmode.h
    dialogs/addtovcsdialog.cpp
    dialogs/addtovcsdialog.h
    dialogs/codecselector.cpp
    dialogs/codecselector.h
    dialogs/externaltoolconfig.cpp
    dialogs/externaltoolconfig.h
    dialogs/filepropertiesdialog.cpp
    dialogs/filepropertiesdialog.h
    dialogs/ioptionspage.cpp
    dialogs/ioptionspage.h
    dialogs/newdialog.cpp
    dialogs/newdialog.h
    dialogs/openwithdialog.cpp
    dialogs/openwithdialog.h
    dialogs/promptoverwritedialog.cpp
    dialogs/promptoverwritedialog.h
    dialogs/readonlyfilesdialog.cpp
    dialogs/readonlyfilesdialog.h
    dialogs/saveitemsdialog.cpp
    dialogs/saveitemsdialog.h
    dialogs/settingsdialog.cpp
    dialogs/settingsdialog.h
    dialogs/shortcutsettings.cpp
    dialogs/shortcutsettings.h
    diffservice.cpp
    diffservice.h
    documentmanager.cpp
    documentmanager.h
    editmode.cpp
    editmode.h
    editormanager/documentmodel.cpp
    editormanager/documentmodel.h
    editormanager/documentmodel_p.h
    editormanager/editorarea.cpp
    editormanager/editorarea.h
    editormanager/editormanager.cpp
    editormanager/editormanager.h
    editormanager/editormanager_p.h
    editormanager/editorview.cpp
    editormanager/editorview.h
    editormanager/editorwindow.cpp
    editormanager/editorwindow.h
    editormanager/ieditor.cpp
    editormanager/ieditor.h
    editormanager/ieditorfactory.cpp
    editormanager/ieditorfactory.h
    editormanager/ieditorfactory_p.h
    editormanager/openeditorsview.cpp
    editormanager/openeditorsview.h
    editormanager/openeditorswindow.cpp
    editormanager/openeditorswindow.h
    editormanager/systemeditor.cpp
    editormanager/systemeditor.h
    editortoolbar.cpp
    editortoolbar.h
    externaltool.cpp
    externaltool.h
    externaltoolmanager.cpp
    externaltoolmanager.h
    fancyactionbar.cpp
    fancyactionbar.h
    fancyactionbar.qrc
    fancytabwidget.cpp
    fancytabwidget.h
    featureprovider.cpp
    featureprovider.h
    fileutils.cpp
    fileutils.h
    find/basetextfind.cpp
    find/basetextfind.h
    find/currentdocumentfind.cpp
    find/currentdocumentfind.h
    find/find.qrc
    find/findplugin.cpp
    find/findplugin.h
    find/findtoolbar.cpp
    find/findtoolbar.h
    find/findtoolwindow.cpp
    find/findtoolwindow.h
    find/highlightscrollbarcontroller.cpp
    find/highlightscrollbarcontroller.h
    find/ifindfilter.cpp
    find/ifindfilter.h
    find/ifindsupport.cpp
    find/ifindsupport.h
    find/itemviewfind.cpp
    find/itemviewfind.h
    find/optionspopup.cpp
    find/optionspopup.h
    find/searchresulttreeitemdelegate.cpp
    find/searchresulttreeitemdelegate.h
    find/searchresulttreeitemroles.h
    find/searchresulttreeitems.cpp
    find/searchresulttreeitems.h
    find/searchresulttreemodel.cpp
    find/searchresulttreemodel.h
    find/searchresulttreeview.cpp
    find/searchresulttreeview.h
    find/searchresultwidget.cpp
    find/searchresultwidget.h
    find/searchresultwindow.cpp
    find/searchresultwindow.h
    find/textfindconstants.h
    findplaceholder.cpp
    findplaceholder.h
    foldernavigationwidget.cpp
    foldernavigationwidget.h
    generalsettings.cpp
    generalsettings.h
    generatedfile.cpp
    generatedfile.h
    helpitem.cpp
    helpitem.h
    helpmanager.cpp
    helpmanager.h
    helpmanager_implementation.h
    icontext.cpp
    icontext.h
    icore.cpp
    icore.h
    idocument.cpp
    idocument.h
    idocumentfactory.cpp
    idocumentfactory.h
    ifilewizardextension.h
    imode.cpp
    imode.h
    inavigationwidgetfactory.cpp
    inavigationwidgetfactory.h
    ioutputpane.cpp
    ioutputpane.h
    iversioncontrol.cpp
    iversioncontrol.h
    iwelcomepage.cpp
    iwelcomepage.h
    iwizardfactory.cpp
    iwizardfactory.h
    jsexpander.cpp
    jsexpander.h
    locator/commandlocator.cpp
    locator/commandlocator.h
    locator/directoryfilter.cpp
    locator/directoryfilter.h
    locator/executefilter.cpp
    locator/executefilter.h
    locator/externaltoolsfilter.cpp
    locator/externaltoolsfilter.h
    locator/filesystemfilter.cpp
    locator/filesystemfilter.h
    locator/ilocatorfilter.cpp
    locator/ilocatorfilter.h
    locator/javascriptfilter.cpp
    locator/javascriptfilter.h
    locator/locator.cpp
    locator/locator.h
    locator/locatorconstants.h
    locator/locatorfiltersfilter.cpp
    locator/locatorfiltersfilter.h
    locator/locatormanager.cpp
    locator/locatormanager.h
    locator/locatorsettingspage.cpp
    locator/locatorsettingspage.h
    locator/locatorwidget.cpp
    locator/locatorwidget.h
    locator/opendocumentsfilter.cpp
    locator/opendocumentsfilter.h
    locator/spotlightlocatorfilter.cpp
    locator/spotlightlocatorfilter.h
    locator/urllocatorfilter.cpp
    locator/urllocatorfilter.h
    loggingviewer.cpp
    loggingviewer.h
    manhattanstyle.cpp
    manhattanstyle.h
    messagebox.cpp
    messagebox.h
    messagemanager.cpp
    messagemanager.h
    mimetypemagicdialog.cpp
    mimetypemagicdialog.h
    mimetypesettings.cpp
    mimetypesettings.h
    minisplitter.cpp
    minisplitter.h
    modemanager.cpp
    modemanager.h
    navigationsubwidget.cpp
    navigationsubwidget.h
    navigationwidget.cpp
    navigationwidget.h
    opendocumentstreeview.cpp
    opendocumentstreeview.h
    outputpane.h
    outputpanemanager.cpp
    outputpanemanager.h
    outputwindow.cpp
    outputwindow.h
    patchtool.cpp
    patchtool.h
    plugindialog.cpp
    plugindialog.h
    plugininstallwizard.cpp
    plugininstallwizard.h
    progressmanager/futureprogress.cpp
    progressmanager/futureprogress.h
    progressmanager/processprogress.cpp
    progressmanager/processprogress.h
    progressmanager/progressbar.cpp
    progressmanager/progressbar.h
    progressmanager/progressmanager.cpp
    progressmanager/progressmanager.h
    progressmanager/progressmanager_p.h
    progressmanager/progressview.cpp
    progressmanager/progressview.h
    progressmanager/taskprogress.cpp
    progressmanager/taskprogress.h
    rightpane.cpp
    rightpane.h
    secretaspect.cpp
    secretaspect.h
    session.cpp
    session.h
    sessiondialog.cpp
    sessiondialog.h
    sessionmodel.cpp
    sessionmodel.h
    sessionview.cpp
    sessionview.h
    settingsdatabase.cpp
    settingsdatabase.h
    sidebar.cpp
    sidebar.h
    sidebarwidget.cpp
    sidebarwidget.h
    statusbarmanager.cpp
    statusbarmanager.h
    systemsettings.cpp
    systemsettings.h
    terminal/searchableterminal.cpp
    terminal/searchableterminal.h
    textdocument.cpp
    textdocument.h
    themechooser.cpp
    themechooser.h
    vcsmanager.cpp
    vcsmanager.h
    versiondialog.cpp
    versiondialog.h
    welcomepagehelper.cpp
    welcomepagehelper.h
    windowsupport.cpp
    windowsupport.h
  EXPLICIT_MOC dialogs/filepropertiesdialog.h
)

extend_qtc_plugin(Core
  CONDITION SHOW_BUILD_DATE
  DEFINES QTC_SHOW_BUILD_DATE
)

extend_qtc_plugin(Core
  CONDITION WITH_TESTS
  SOURCES
    locator/locator_test.cpp
    locator/locatorfiltertest.cpp
    locator/locatorfiltertest.h
    testdatadir.cpp
    testdatadir.h
)

extend_qtc_plugin(Core
  CONDITION WIN32
  SOURCES progressmanager/progressmanager_win.cpp
)

extend_qtc_plugin(Core
  CONDITION APPLE
  DEPENDS ${FWAppKit}
  SOURCES
    progressmanager/progressmanager_mac.mm
)

extend_qtc_plugin(Core
  CONDITION (NOT WIN32) AND (NOT APPLE)
  SOURCES progressmanager/progressmanager_x11.cpp
)

extend_qtc_plugin(Core
  CONDITION BUILD_WITH_CRASHPAD OR BUILD_WITH_SENTRY
  DEFINES ENABLE_CRASHREPORTING
)

extend_qtc_plugin(Core
  CONDITION BUILD_WITH_CRASHPAD OR (BUILD_WITH_SENTRY AND SENTRY_CRASHPAD_PATH)
  DEFINES CRASHREPORTING_USES_CRASHPAD
)

set(FONTS_BASE "${QtCreator_SOURCE_DIR}/src/share/3rdparty/studiofonts/")
qt_add_resources(Core
  CoreWelcomeScreenFonts_rcc
  BASE ${FONTS_BASE}
  PREFIX "studiofonts"
  FILES "${FONTS_BASE}/TitilliumWeb-Regular.ttf"
)

=== src/plugins/fakevim/CMakeLists.txt ===
add_qtc_plugin(FakeVim
  PLUGIN_DEPENDS Core TextEditor
  PLUGIN_TEST_DEPENDS CppEditor
  SOURCES ${TEST_SOURCES}
    fakevim.qrc
    fakevimactions.cpp fakevimactions.h
    fakevimhandler.cpp fakevimhandler.h
    fakevimplugin.cpp
    fakevimtr.h
)

extend_qtc_plugin(FakeVim
  CONDITION WITH_TESTS
  SOURCES fakevim_test.cpp
)

=== src/plugins/insight/CMakeLists.txt ===
add_qtc_plugin(Insight
    CONDITION TARGET QtCreator::QmlDesigner
    PLUGIN_DEPENDS
        QtCreator::Core QtCreator::QtSupport QtCreator::QmlDesigner QtCreator::QmlProjectManager QtCreator::ProjectExplorer
    DEPENDS
        QtCreator::Utils
        Qt6::Core Qt6::CorePrivate Qt6::Widgets
        Qt6::Qml Qt6::QmlPrivate Qt6::Quick Qt6::QuickWidgets
    SOURCES
        insightplugin.cpp
        insightmodel.cpp insightmodel.h
        insightview.cpp insightview.h
        insightwidget.cpp insightwidget.h
)

=== debian/changelog ===
qtcreator (17.0.1-0zneon+24.04+noble+unstable+build15) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Sep 2025 08:51:55 +0000

qtcreator (17.0.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Mon, 01 Sep 2025 18:50:14 +1000

qtcreator (17.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Sat, 12 Jul 2025 19:47:48 +1000

qtcreator (16.0.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Sun, 13 Apr 2025 07:22:18 +1000

qtcreator (16.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Tue, 18 Mar 2025 10:39:48 +1000

qtcreator (15.0.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sun, 09 Feb 2025 13:46:29 +1000

qtcreator (15.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Tue, 10 Dec 2024 18:12:33 +1000

qtcreator (14.0.2-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Thu, 08 Aug 2024 11:14:34 +1000

qtcreator (14.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sat, 27 Jul 2024 11:56:55 +1000

qtcreator (13.0.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sat, 24 Feb 2024 13:07:34 +1000

qtcreator (12.0.1-0neon) jammy; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Wed, 20 Dec 2023 14:32:18 +1000

qtcreator (11.0.3-0neon) jammy; urgency=medium

  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Thu, 02 Nov 2023 08:08:24 +1000

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>
Build-Depends: clang (>= 1:10~),
               clangd (>= 1:14~),
               cmake,
               debhelper-compat (= 13),
               diffutils,
               libappstream-glib-dev,
               libclang-14-dev,
               libclang-dev (>= 1:10~),
               libdw-dev,
               libedit-dev,
               libelf-dev,
               libicu-dev,
               libqt-advanced-docking-system-dev,
               librust-rustc-demangle-dev,
               libsecret-1-dev,
               libsqlite3-dev,
               libsystemd-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:10~),
               ninja-build,
               pkg-config,
               python3:any,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-base-doc,
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qt6-doc-dev,
               qt6-quick3d-dev,
               qt6-quicktimeline-dev,
               qt6-serialport-dev,
               qt6-shadertools-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-private-dev,
               qt6-webengine-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://invent.kde.org/neon/qt6/qtcreator.git
Vcs-Browser: https://invent.kde.org/neon/qt6/qtcreator
Maintainer: Neon CI <neon@kde.org>

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:14~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-base-dev-tools,
            qt6-declarative-dev-tools,
            qt6-qmltooling-plugins,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            qtcreator-doc,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5),
          cmake,
          g++,
          git,
          meson,
          python3-pylsp,
          subversion,
          valgrind
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-imageformats, ${misc:Depends}
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# Do not build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE

# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

# the dwz processing for all the libraries and plugins can take a lot of memory,
# which may be not enough on some architectures (typically 32bit), resulting in
# dwz failing with "Could not allocate memory: Cannot allocate memory" errors;
# hence, on architectures where we see this result, try to use a more memory
# friendly processing for a lower number of DIEs (dwz default is 10M)
archs_with_dwz_low_mem = armel armhf mipsel
dwz_low_mem = 3000000

archs_using_clang = mips64el mipsel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_using_clang)))
export CC=clang
export CXX=clang++
export DEB_CFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_CXXFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
EXTRA_CMAKE_ARGS += -DBUILD_WITH_PCH=OFF
endif

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-Djournald=ON \
		-DWITH_TESTS=OFF \
		-DBUILD_TESTING=OFF \
		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
		-DBUILD_PLUGIN_CLANGREFACTORING=ON \
		-DBUILD_PLUGIN_CLANGPCHMANAGER=ON \
		-DCMAKE_DISABLE_FIND_PACKAGE_litehtml=yes \
		-DEXTERNAL_XXD=no \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF) \
		$(EXTRA_CMAKE_ARGS)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	#rm debian/tmp/usr/bin/qtcreator.sh

	# License files of the embedded copy of KSyntaxHighlighting
	rm -rf debian/tmp/usr/share/qtcreator/generic-highlighter/syntax/licenses/

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -perm /111 -exec chmod -v -x {} \;

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt6DesignerComponents 6 qt6-tools (>= $(call upstream_version_of_pkg,qt6-tools)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator
	rm debian/shlibs.local

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_with_dwz_low_mem)))
override_dh_dwz:
	dh_dwz -- --low-mem-die-limit $(dwz_low_mem)
endif

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/ \
https://qt-mirror.dannhauer.de/official_releases/qtcreator/([\d\.]*)/([\d\.]*)/qt-creator-opensource-src-([^-]*)\.tar\.xz
